#ifndef _NNTP_H
#define _NNTP_H

#ifndef _GLOBAL_H
#include "global.h"
#endif

#ifndef _TIMER_H
#include "timer.h"
#endif

#ifndef _SMTP_H
#include "smtp.h"
#endif

#define LineLen 512

struct nntpsv {
    int s;
    int ret;
	int debug;
	int slave;
    unsigned  first;
    unsigned  last;
    unsigned  pointer;
    unsigned  hold_i;

	char buf[LineLen];
    char *newnews;
    char *path;
    char *id;
    FILE *ihave;

    int32 dest;
	int32 unixtime;
	long ftime;
    struct date *datest;
    struct time *timest;

    struct article *ap;
};
#define NULLNNTPSV (struct nntpsv *)0

struct article {
    char *group;
    char *id;
    char *path;
    unsigned number;
    unsigned tmpu;
    struct article *next;
};
#define NULLARTICLE (struct article *)0

struct post {
    char *user;
    char *reply;
    char *sig;
    char *organ;
	char *fullname;
};
#define NULLPOST (struct post *)0

#ifdef XXX
struct groups {
    struct article *a;
    struct article *next;
};
#define NULLGROUP (struct groups *)0
#endif

struct head {
    char *from;
    char *reply_to;
    char *subject;
    char *id;
};
#define NULLHEAD (struct head *)0

struct g_list {
    char *str;
    struct g_list *next;
};
#define NULLG (struct g_list *)0

#ifdef XXX
struct search {
    struct g_list *not;
    struct g_list *all;
    struct g_list *group;
};
#define NULLSEARCH (struct search *)0

struct DFREE {
    unsigned char drive;
    unsigned long bytes;
    struct DFREE *next;
};
#define NULLDRV (struct DFREE *)0
#endif

struct Servers {
	struct timer nntpt;
	char *name;
	int32 dest;
	char *newsgroups;   	/* list of newsgroups */
	int lowtime;            /* for connect window */
	int hightime;
    struct Servers *next;
};
#define NULLSERVER (struct Servers *)0

extern char NEol[];

int	nntp1 	__ARGS((int argc, char *argv[], void *p));
int nntp0 	__ARGS((int argc, char *argv[], void *p));
int donntp 	__ARGS((int argc, char *argv[], void *p));
int nnGpost __ARGS((FILE *data,char *from,struct list *le));

/* in nntpcli.c */
extern char *Host;
extern char msgid[];
extern char subj[];
extern char ngrps[];
extern char frm[];
extern char reply_to[];
extern char pth[];
extern int LzwActive;
extern int16 Nntpquiet;
extern struct post Post;
extern struct Servers *Nntpserver;
extern unsigned short Nntpmaxcli;

/* in nntpserv.c */
extern char fatal[];
int doarticle __ARGS((char *buf,struct nntpsv *mp,char flag));
void nntpserv __ARGS((int s,void *unused,void *p));

/* in nntpsubr.c */
extern int Filecheck;
int check_system __ARGS((void));
int recv_file __ARGS((FILE *fp,int s));
int check_article __ARGS((char *id));
int xfer_article2 __ARGS((FILE *fp,struct nntpsv *mp));
int check_blank __ARGS((char *bp));
int get_path2 __ARGS((struct article *ap));
int32 make_nntime __ARGS((struct date *d,struct time *t,char *str));
int newnews __ARGS((char *string,struct nntpsv *mp,FILE *f));

#endif /* _NNTP_H */
